module Frp where

import KDTree
import Point
import Nn

frp :: (Read a,Ord a,Num a) => [Point a] -> [Point a]
frp lista = faz_frp(build lista)

faz_frp (Leaf lista) = nn lista
faz_frp (Node coord x esq dir) = merge (faz_frp esq) (faz_frp dir)

merge lista1 lista2 =	if menor == dist1
			then (reverso lista1) ++ lista2
			else	if menor == dist2
				then lista2 ++ lista1
				else	if menor == dist3
					then lista1 ++ lista2
					else lista1 ++ (reverso lista2)
	where
		dist1 = sqrdist ((head lista1),(head lista2))
		dist2 = sqrdist ((head lista1),(last lista2))
		dist3 = sqrdist ((last lista1),(head lista2))
		dist4 = sqrdist ((last lista1),(last lista2))
		menor = minimo  dist1 [dist2,dist3,dist4]

minimo menor [] = menor
minimo menor (a:lista) =	if a < menor
				then minimo a lista
				else minimo menor lista

reverso [] = []
reverso (a:lista) = (reverso lista) ++ [a]
