module Greedy where
import Point
import KDTree
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
-----Ex.11-----------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------


arestas_aux::(Num a,Ord a)=>Point a->[Point a]->[(a,(Point a, Point a))]
arestas_aux ponto [] = []
arestas_aux ponto (a:xs) = [(cDist ponto a,(ponto,a))] ++ arestas_aux ponto xs

arestas1::(Num a,Ord a)=>[Point a] -> [(a,(Point a, Point a))]
arestas1 [] = []
arestas1 (a:xs) = arestas_aux a xs ++ arestas1 xs

arestas::(Num a,Ord a)=>[Point a] -> [(Point a, Point a)]
arestas [] = []
arestas xs = [ pontos | (distancia,pontos) <- qSortX (arestas1 xs) ]

transforma_em_lista ::(Ord a)=> (Point a, Point a) -> [Point a]
transforma_em_lista (x,y) = [x,y] 

greedy :: (Num a,Ord a)=> [Point a] -> [Point a]
greedy [] = []
greedy [x] = [x]
greedy xs = greedy_aux (tail ys) ([transforma_em_lista (head ys)])
	where
		ys = arestas xs

greedy_aux :: (Num a,Ord a) => [(Point a, Point a)] -> [[Point a]] -> [Point a]
greedy_aux [] aux = head aux
greedy_aux xs aux = if se_eh_grau2 aux (head xs)
			then greedy_aux (tail xs) aux --Pula aresta
			else greedy_aux (tail xs) (insere_tour (head xs) aux [])

-- Verifica se esta no meio, ou seja, se um ponto ira ter 3 arestas. Nao adicionara esse ponto
se_eh_grau2 :: (Num a,Ord a) => [[Point a]] -> (Point a, Point a) -> Bool
se_eh_grau2 [] par = False
se_eh_grau2 ys par = if (elem (fst par) lista_sem_pontas || elem (snd par) lista_sem_pontas )
			then True
			else se_eh_grau2 (tail ys) par
		where
			lista_sem_pontas = init (tail(head ys))

-- Insere o ponto na lista de tours
insere_tour :: (Num a,Ord a) => (Point a, Point a) -> [[Point a]] -> [[Point a]] -> [[Point a]]
insere_tour par [] aux2 = ([transforma_em_lista par]++aux2) 
insere_tour par aux aux2 = if sao_iguais par then aux++aux2 else
			if ( (last(head aux)) == (fst par) || (last(head aux)) == (snd par))
			then  let t1=concatena_ultimo (head aux) par
			      in if (head t1 == last t1) 
				 then (aux2 ++ aux)
				 else concerta_lista1 (t1) (tail aux) aux2
			else	if (head(head aux) == (fst par) || (head (head aux)) == (snd par))
				then	let t2 = concatena_primeiro (head aux) par
					in if (head t2 == last t2)  
					   then (aux2 ++ aux)
					   else concerta_lista2 (t2) (tail aux) aux2
			else insere_tour (par) (tail aux) (aux2 ++[head aux])

concatena_ultimo:: (Num a,Ord a) => [Point a] -> (Point a, Point a) -> [Point a]
concatena_ultimo ys x =  if (fst x == last ys)
		  	then ys ++ [snd x]
			else ys ++ [fst x]

concatena_primeiro:: (Num a,Ord a) => [Point a] -> (Point a, Point a) -> [Point a]
concatena_primeiro ys x =  if (fst x == head ys)
		  	then [snd x] ++ ys
			else [fst x] ++ ys

concerta_lista1 :: (Num a,Ord a) => [Point a] -> [[Point a]] -> [[Point a]] -> [[Point a]]
concerta_lista1 ys [] aux2 = aux2 ++ [ys]
concerta_lista1 ys aux aux2 = if (last ys == head (head aux))
		  	 	then aux2++[(init ys ++ (head aux))]++(tail aux)
		  	 	else if (last ys == last (head aux))
					then aux2++[(init ys ++ (reverse(head aux)))]++(tail aux)
					else concerta_lista1 ys (tail aux) (aux2 ++[head aux])

concerta_lista2 :: (Num a,Ord a) => [Point a] -> [[Point a]] -> [[Point a]] -> [[Point a]]
concerta_lista2 ys [] aux2 = aux2 ++ [ys]
concerta_lista2 ys aux aux2 = if (head ys == head (head aux))
		  	 	then aux2++[(reverse(tail ys) ++ (head aux))]++(tail aux)
		  	 	else if (head ys == last (head aux))
					then aux2++[(head aux)++(tail ys)]++(tail aux)
					else concerta_lista2 ys (tail aux) (aux2 ++[head aux])

sao_iguais::(Num a,Ord a) => (Point a, Point a) -> Bool
sao_iguais pontos = fst pontos == snd pontos