module Binpq where
import Point
import KDTree
data Binpq a =
	PNull
	|PNode a (Binpq a) (Binpq a)
	deriving Show

--------------------------------------------------------------------------------------------------
sSplitXY op a [] = []
sSplitXY op a (b:x)
	| op a b = b:(sSplitXY op a x)
	| otherwise = sSplitXY op a x

qSortXY [] = []
qSortXY (b:x) = qSortXY (sSplitXY (>) b x) ++ b:(qSortXY(sSplitXY (<=) b x))

--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
-----Ex.4-----------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
pTree :: (Ord a) => [a] -> Binpq a
pTree [] = PNull
pTree xs = PNode vHeadOPts vTreeOne vTreeTwo 
	where 	vOrdPoints = qSortXY xs
		vHeadOPts = head vOrdPoints
		vTailOPts = tail vOrdPoints
		vTreeOne = pTree (take (div (length vTailOPts) 2) vTailOPts)
		vTreeTwo = pTree (drop (div (length vTailOPts) 2) vTailOPts)

buildPT ::(Ord a) => [a] -> Binpq a
buildPT xs = pTree xs

merge ::(Ord a)=> Binpq a -> Binpq a -> Binpq a
merge PNull ys = ys
merge xs PNull = xs
merge (PNode a xs ys) (PNode b us vs) = if (a < b) 
	then PNode a (merge ys (PNode b us vs)) xs
	else PNode b (merge (PNode a xs ys) vs) us

insert ::(Ord a)=> Binpq a -> a -> Binpq a
insert (PNode a xs ys) b = merge (PNode a xs ys) (PNode b PNull PNull)

findMin::Ord a => Binpq a -> a
findMin (PNode a xs ys) = a

delmin ::(Ord a)=> Binpq a -> Binpq a
delmin (PNode a xs ys) = merge xs ys

--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
-----Ex.5-----------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------

isbinpq :: (Ord a)=> Binpq a -> Bool
isbinpq PNull = True
isbinpq (PNode a PNull PNull) = True
isbinpq (PNode a xs ys)
		| ((a > (findMin xs)) || (a > (findMin ys))) = False
		| otherwise = isbinpq xs && isbinpq ys