module Pqgreedy where

import Point
import KDTree
import KdtreeAux
import Binpq

--pqgreedy :: (Read a, Num a, Ord a) => [Point a] -> [Point a]
--pqgreedy lista = faz_tour [] pq kdtree (length lista)
pqgreedy lista = faz_tour [] pq kdtree (length lista)
	where
		kdtree = build lista
		pq = (tva (prioridades lista kdtree))

prioridades [] kdtree = []
prioridades (a:lista) kdtree = (sqrdist (a,x),(a,x)):(prioridades lista kdtree)
	where
		x = nn a kdtree

faz_tour tour pq kdtree tam =	if length tour == tam-1
				then comeca_tour tour
				else	if 2 == ocorrencias p1 tour
					then	if 2 == ocorrencias p2 tour
						then faz_tour tour npq kdtree tam
						else faz_tour tour (insert npq (sqrdist (p2,nnp2),(p2,nnp2))) kdtree tam
					else	if 2 == ocorrencias p2 tour
					then faz_tour tour (insert npq (sqrdist (p1,nnp1),(p1,nnp1))) kdtree tam
					else	if 1 == ocorrencias p1 tour
						then faz_tour ((p1,p2):tour) npq (delete p1 kdtree) tam
						else	if 1== ocorrencias p2 tour
							then faz_tour ((p1,p2):tour) npq (delete p2 kdtree) tam
							else faz_tour ((p1,p2):tour) npq kdtree tam
	where
		npq = delmin pq
		(dist,(p1,p2)) = pega_min pq
		nnp2 = (nn p2 kdtree)
		nnp1 = (nn p1 kdtree)

ocorrencias ponto [] = 0
ocorrencias ponto ((p1,p2):lista) =	if (p1 == ponto) || (p2 == ponto)
					then 1 + ocorrencias ponto lista
					else ocorrencias ponto lista

comeca_tour lista = ponta:(faz_tour2 ponta lista)
	where
		ponta = pega_ponta lista

pega_ponta lista =	if null ponto1
			then head [ p2 | (p1,p2)<-lista , (ocorrencias p2 lista == 1) ]
			else head ponto1
	where
		ponto1  = [ p1 | (p1,p2)<-lista , (ocorrencias p1 lista == 1) ]

faz_tour2 ponto [] = []
faz_tour2 ponto lista = a:(faz_tour2 a (deleta aresta lista))
	where
		(a,aresta) = pega_aresta_com ponto lista

--assumindo que sempre ha uma aresta com o ponto dado
--pega_aresta_com ponto [] = 
pega_aresta_com ponto ((p1,p2):lista) =	if p1 == ponto
					then (p2,(p1,p2))
					else	if p2 == ponto
						then (p1,(p1,p2))
						else if null lista
						then (p1,(p1,p2))
						else pega_aresta_com ponto lista

--assumindo que x sempre ocorre em a:lista
deleta x (a:lista) =	if a == x
			then lista
			else a:(deleta x lista)

