module PQGreedy where

import Point
import KDTree
import Greedy

--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
-----Ex.14----------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------



pqarestas_aux::(Num a,Ord a) => [Point a] -> KDtree a -> [(a,(Point a, Point a))]
pqarestas_aux [] kdtree = []
pqarestas_aux xs kdtree = [(cDist a (findnn a (delete a kdtree)),(a,findnn a (delete a kdtree))) | a <- xs ]


pqarestas::(Num a,Ord a) => [Point a] -> [(Point a, Point a)]
pqarestas [] = []
pqarestas xs = [ pontos | (distancia,pontos) <- qSortX (pqarestas_aux xs kdtree) ]
	where
		kdtree = build xs


pqgreedy :: (Num a,Ord a)=> [Point a] -> [Point a]
pqgreedy [] = []
pqgreedy [x] = [x]
pqgreedy xs = pqgreedy_aux (tail ys) ([transforma_em_lista (head ys)]) (build xs)
	where
		ys = pqarestas xs

pqgreedy_aux :: (Num a,Ord a) => [(Point a, Point a)] -> [[Point a]] -> KDtree a -> [Point a]
pqgreedy_aux [] aux kdtree = concatena_tours aux
pqgreedy_aux xs aux kdtree = 
			if (se_eh_grau2 aux (head xs) || sao_pontas aux (head xs))
			then	pqgreedy_aux (tail xs) (insere_tour (proximo_ponto (head xs) aux kdtree) aux []) kdtree
			else	pqgreedy_aux (tail xs) (insere_tour (head xs) aux []) kdtree


sao_pontas :: (Num a,Ord a) => [[Point a]] -> (Point a, Point a) -> Bool
sao_pontas [] pontos = False
sao_pontas tours pontos = if (((fst pontos) == (head(head tours)) && (snd pontos) == (last(head tours))) || (fst pontos) == (last(head tours)) && (snd pontos) == (head(head tours)))
			then True
			else sao_pontas (tail tours) pontos

ponto_eh_grau2 :: (Num a,Ord a) => [[Point a]] -> Point a -> Bool
ponto_eh_grau2 [] ponto = False
ponto_eh_grau2 tours ponto = if (elem ponto (init (tail(head tours))))
				then True
				else ponto_eh_grau2 (tail tours) ponto


proximo_ponto :: (Num a,Ord a) => (Point a, Point a) -> [[Point a]] -> KDtree a -> (Point a, Point a)
proximo_ponto (ponto,proximo) aux kdtree = 
			let proximo2 = ( ponto,findnn ponto (delete proximo kdtree) )
			in	if (se_eh_grau2 aux proximo2 || sao_pontas aux proximo2)
				then	proximo_ponto proximo2 aux (delete proximo kdtree)
				else	proximo2



concatena_tours :: (Num a,Ord a) => [[Point a]] -> [Point a]
concatena_tours [] = []
concatena_tours (a:xs) = a ++ concatena_tours xs

