module Pqgreedy where

import Point
import KDTree
import Greedy


data Binpqg a =
	 Nill
	|Nodeg (a, Point a, Point a) (Binpqg a) (Binpqg a)
	deriving Show

pqgreedy []	=	[]
pqgreedy [p]	=	[p]
pqgreedy ws	=
  let	tour	=	doitpq binpq tree [] [] []
  in	if	( tour == [] )
	then	( error ("putz!") )
	else	( head tour )
  where	tree	=	KDTree.build ws
	binpq	=	buildbpqg ws tree Nill

buildbpqg [] _ binpq		=	binpq
buildbpqg (w:ws) tree binpq	=
  let	nnp	=	KDTree.nn w tree
	edge	=	(Greedy.dist2 w nnp, w, nnp)
  in	buildbpqg ws tree (insertg binpq edge)

doitpq Nill _ tour _ _		=	tour
doitpq binpq tree tour gs1 gs2	=
  let
	((d,a,b),binpq2)	=	pop binpq
	newTour (ga,sa) (gb,sb)	=	Greedy.insertEdge a ga sa b gb sb tour
	upt (ga,sa) (gb,sb)	=	Greedy.update a ga b gb gs1 gs2
  in
  case ( Greedy.choose (a,b) tour gs1 gs2 ) of
	ItsOk ia ib		->	doitpq binpq2 tree (newTour ia ib) (fst(upt ia ib)) (snd(upt ia ib))
	FindNew (ga,sa) (gb,sb)	->	if	( ga == 0 && sb == [] )
					then	( newNN a b binpq tree tour gs1 gs2 )
					else	if	( ga == 2 )
						then	( newNN b a binpq tree tour gs1 gs2 )
						else	( newNN a b binpq tree tour gs1 gs2 )

newNN x y binpq tree tour gs1 gs2	=
  let
	tree2		=	KDTree.delete y tree
	nnk		=	KDTree.nn2 x tree2
  in
  case ( nnk ) of
	EmptyTree	->	tour
	EmptyLeaf	->	reSearch x binpq tree2 tour gs1 gs2
	NNPoint (d2,y2)	->	doitpq (insertg binpq (d2,x,y2)) tree2 tour gs1 gs2

reSearch x binpq tree tour gs1 gs2	=
  let
	tree2		=	KDTree.rebuild tree
	nnk		=	KDTree.nn2 x tree2
  in
  case ( nnk ) of
	EmptyTree	->	tour
	EmptyLeaf	->	tour
	NNPoint (d2,y2)	->	doitpq (insertg binpq (d2,x,y2)) tree2 tour gs1 gs2


mergeg Nill Nill=	Nill
mergeg Nill ys	=	ys
mergeg xs Nill	=	xs
mergeg t1@(Nodeg a xs ys) t2@(Nodeg b us vs)
	|a < b		=	Nodeg a (mergeg ys t2) xs
	|otherwise	=	Nodeg b (mergeg t1 vs) us

insertg Nill a			=	Nodeg a Nill Nill
insertg t0@(Nodeg a xs ys) b	=	mergeg t0 (Nodeg b Nill Nill)

findming (Nodeg a xs ys)	=	a
delming (Nodeg a Nill Nill)	=	Nill
delming Nill			=	Nill
delming  (Nodeg a xs ys)	=	mergeg xs ys
pop b@binpq			=	(findming b, delming b)


